package com.sunwin.metro.bean;

import com.alibaba.fastjson.JSON;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 电表值对象
 * @author: xuYJ
 * @create: 2021-04-14 16:50
 **/
public class ElectricityMeter implements Serializable {

    private String meter_number;


    private Double electric_total_active;


    private Map<String,Double> frequency;

    private Map<String,Double> a_current;

    private Map<String,Double> b_current;

    private Map<String,Double> c_current;

    private Map<String,Double> a_voltage;

    private Map<String,Double> b_voltage;

    private Map<String,Double> c_voltage;

    private Map<String,Double> total_negative_active;

    private Map<String,Double> a_negative_active;

    private Map<String,Double> b_negative_active;

    private Map<String,Double> c_negative_active;

    private Map<String,Double> total_power_factor;

    private Map<String,Double> a_power_factor;

    private Map<String,Double> b_power_factor;

    private Map<String,Double> c_power_factor;

    private Map<String,Double> total_apparent_power;

    private Map<String,Double> a_apparent_power;

    private Map<String,Double> b_apparent_power;

    private Map<String,Double> c_apparent_power;

    private Map<String,Double> total_active_power;

    private Map<String,Double> a_active_power;

    private Map<String,Double> b_active_power;

    private Map<String,Double> c_active_power;

    private Integer electric_status;

    private Map<String,Double> total_active;

    private String update_time;

    public ElectricityMeter() {
    }

    public ElectricityMeter(String meter_number, Integer electric_status, String update_time) {
        this.meter_number = meter_number;
        this.electric_status = electric_status;
        this.update_time = update_time;
    }

    public String getMeter_number() {
        return meter_number;
    }

    public void setMeter_number(String meter_number) {
        this.meter_number = meter_number;
    }

    public Double getElectric_total_active() {
        return electric_total_active;
    }

    public void setElectric_total_active(Double electric_total_active) {
        this.electric_total_active = electric_total_active;
    }

    public Map<String, Double> getFrequency() {
        return frequency;
    }

    public void setFrequency(Map<String, Double> frequency) {
        this.frequency = frequency;
    }

    public Map<String, Double> getA_current() {
        return a_current;
    }

    public void setA_current(Map<String, Double> a_current) {
        this.a_current = a_current;
    }

    public Map<String, Double> getB_current() {
        return b_current;
    }

    public void setB_current(Map<String, Double> b_current) {
        this.b_current = b_current;
    }

    public Map<String, Double> getC_current() {
        return c_current;
    }

    public void setC_current(Map<String, Double> c_current) {
        this.c_current = c_current;
    }

    public Map<String, Double> getA_voltage() {
        return a_voltage;
    }

    public void setA_voltage(Map<String, Double> a_voltage) {
        this.a_voltage = a_voltage;
    }

    public Map<String, Double> getB_voltage() {
        return b_voltage;
    }

    public void setB_voltage(Map<String, Double> b_voltage) {
        this.b_voltage = b_voltage;
    }

    public Map<String, Double> getC_voltage() {
        return c_voltage;
    }

    public void setC_voltage(Map<String, Double> c_voltage) {
        this.c_voltage = c_voltage;
    }

    public Map<String, Double> getTotal_negative_active() {
        return total_negative_active;
    }

    public void setTotal_negative_active(Map<String, Double> total_negative_active) {
        this.total_negative_active = total_negative_active;
    }

    public Map<String, Double> getA_negative_active() {
        return a_negative_active;
    }

    public void setA_negative_active(Map<String, Double> a_negative_active) {
        this.a_negative_active = a_negative_active;
    }

    public Map<String, Double> getB_negative_active() {
        return b_negative_active;
    }

    public void setB_negative_active(Map<String, Double> b_negative_active) {
        this.b_negative_active = b_negative_active;
    }

    public Map<String, Double> getC_negative_active() {
        return c_negative_active;
    }

    public void setC_negative_active(Map<String, Double> c_negative_active) {
        this.c_negative_active = c_negative_active;
    }

    public Map<String, Double> getTotal_power_factor() {
        return total_power_factor;
    }

    public void setTotal_power_factor(Map<String, Double> total_power_factor) {
        this.total_power_factor = total_power_factor;
    }

    public Map<String, Double> getA_power_factor() {
        return a_power_factor;
    }

    public void setA_power_factor(Map<String, Double> a_power_factor) {
        this.a_power_factor = a_power_factor;
    }

    public Map<String, Double> getB_power_factor() {
        return b_power_factor;
    }

    public void setB_power_factor(Map<String, Double> b_power_factor) {
        this.b_power_factor = b_power_factor;
    }

    public Map<String, Double> getC_power_factor() {
        return c_power_factor;
    }

    public void setC_power_factor(Map<String, Double> c_power_factor) {
        this.c_power_factor = c_power_factor;
    }

    public Map<String, Double> getTotal_apparent_power() {
        return total_apparent_power;
    }

    public void setTotal_apparent_power(Map<String, Double> total_apparent_power) {
        this.total_apparent_power = total_apparent_power;
    }

    public Map<String, Double> getA_apparent_power() {
        return a_apparent_power;
    }

    public void setA_apparent_power(Map<String, Double> a_apparent_power) {
        this.a_apparent_power = a_apparent_power;
    }

    public Map<String, Double> getB_apparent_power() {
        return b_apparent_power;
    }

    public void setB_apparent_power(Map<String, Double> b_apparent_power) {
        this.b_apparent_power = b_apparent_power;
    }

    public Map<String, Double> getC_apparent_power() {
        return c_apparent_power;
    }

    public void setC_apparent_power(Map<String, Double> c_apparent_power) {
        this.c_apparent_power = c_apparent_power;
    }

    public Map<String, Double> getTotal_active_power() {
        return total_active_power;
    }

    public void setTotal_active_power(Map<String, Double> total_active_power) {
        this.total_active_power = total_active_power;
    }

    public Map<String, Double> getA_active_power() {
        return a_active_power;
    }

    public void setA_active_power(Map<String, Double> a_active_power) {
        this.a_active_power = a_active_power;
    }

    public Map<String, Double> getB_active_power() {
        return b_active_power;
    }

    public void setB_active_power(Map<String, Double> b_active_power) {
        this.b_active_power = b_active_power;
    }

    public Map<String, Double> getC_active_power() {
        return c_active_power;
    }

    public void setC_active_power(Map<String, Double> c_active_power) {
        this.c_active_power = c_active_power;
    }

    public Integer getElectric_status() {
        return electric_status;
    }

    public void setElectric_status(Integer electric_status) {
        this.electric_status = electric_status;
    }

    public Map<String, Double> getTotal_active() {
        return total_active;
    }

    public void setTotal_active(Map<String, Double> total_active) {
        this.total_active = total_active;
    }

    public String getUpdate_time() {
        return update_time;
    }

    public void setUpdate_time(String update_time) {
        this.update_time = update_time;
    }

    @Override
    public String toString() {
        return "ElectricityMeter{" +
                "meter_number='" + meter_number + '\'' +
                ", electric_total_active=" + JSON.toJSONString(electric_total_active) +
                ", frequency=" + JSON.toJSONString(frequency) +
                ", a_current=" + JSON.toJSONString(a_current) +
                ", b_current=" + JSON.toJSONString(b_current) +
                ", c_current=" + JSON.toJSONString(c_current) +
                ", a_voltage=" + JSON.toJSONString(a_voltage) +
                ", b_voltage=" + JSON.toJSONString(b_voltage) +
                ", c_voltage=" + JSON.toJSONString(c_voltage) +
                ", total_negative_active=" + JSON.toJSONString(total_negative_active) +
                ", a_negative_active=" + JSON.toJSONString(a_negative_active) +
                ", b_negative_active=" + JSON.toJSONString(b_negative_active) +
                ", c_negative_active=" + JSON.toJSONString(c_negative_active) +
                ", total_power_factor=" + JSON.toJSONString(total_power_factor) +
                ", a_power_factor=" + JSON.toJSONString(a_power_factor) +
                ", b_power_factor=" + JSON.toJSONString(b_power_factor) +
                ", c_power_factor=" + JSON.toJSONString(c_power_factor) +
                ", total_apparent_power=" + JSON.toJSONString(total_apparent_power) +
                ", a_apparent_power=" + JSON.toJSONString(a_apparent_power) +
                ", b_apparent_power=" + JSON.toJSONString(b_apparent_power) +
                ", c_apparent_power=" + JSON.toJSONString(c_apparent_power) +
                ", total_active_power=" + JSON.toJSONString(total_active_power) +
                ", a_active_power=" + JSON.toJSONString(a_active_power) +
                ", b_active_power=" + JSON.toJSONString(b_active_power) +
                ", c_active_power=" + JSON.toJSONString(c_active_power) +
                ", electric_status=" + electric_status +
                ", total_active=" + JSON.toJSONString(total_active) +
                ", update_time='" + update_time + '\'' +
                '}';
    }
}
