package com.sunwin.metro.consumer;

import org.apache.flink.api.common.typeinfo.BasicTypeInfo;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.api.java.tuple.Tuple4;
import org.apache.flink.api.java.typeutils.TupleTypeInfo;
import org.apache.flink.streaming.connectors.kafka.KafkaDeserializationSchema;
import org.apache.kafka.clients.consumer.ConsumerRecord;

import java.nio.charset.StandardCharsets;

/**
 * @author xuYJ
 * @description: kafka定义约束
 * @create: 2020-08-26 14:10
 */
public class CustomKafkaDeserializationSchema implements KafkaDeserializationSchema<Tuple4<String, Integer, Long, String>> {
    @Override
    public boolean isEndOfStream(Tuple4<String, Integer, Long, String> nextElement) {
        return false;
    }

    @Override
    public Tuple4<String, Integer, Long, String> deserialize(ConsumerRecord<byte[], byte[]> record) throws Exception {
        return new Tuple4<>(record.topic(), record.partition(), record.offset(), new String(record.value(), StandardCharsets.UTF_8));
    }

    @Override
    public TypeInformation<Tuple4<String, Integer, Long, String>> getProducedType() {
        return new TupleTypeInfo<>(BasicTypeInfo.STRING_TYPE_INFO, BasicTypeInfo.INT_TYPE_INFO, BasicTypeInfo.LONG_TYPE_INFO, BasicTypeInfo.STRING_TYPE_INFO);
    }
}
