package com.sunwin.metro.flatmap;

import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.api.java.tuple.Tuple2;
import org.apache.flink.util.Collector;

import java.util.List;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 采集webSocket服务端信息拆分每个设备数据
 * @author: xuYJ
 * @create: 2021-02-19 11:04
 **/
public class DeviceClientFlatmap implements FlatMapFunction<Map<String, List<String>>, Tuple2<String, String>> {
    @Override
    public void flatMap(Map<String, List<String>> listMap, Collector<Tuple2<String, String>> collector) throws Exception {
        if (null != listMap && !listMap.isEmpty()) {
            List<String> list = listMap.get("devices");
            for (String s : list) {
                collector.collect(new Tuple2<>(String.valueOf((s.hashCode() > 0 ? s.hashCode() : -s.hashCode()) % 3), s));
            }
        }
    }
}
