package com.sunwin.metro.flatmap;

import com.alibaba.fastjson.JSONArray;
import com.sunwin.metro.bean.Meter;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.List;

/**
 * @program: sunwin_metro
 * @description: 转化源数据生成不同仪表清单
 * @author: xuYJ
 * @create: 2021-04-25 15:40
 **/
public class MeterListFlatmap implements FlatMapFunction<String, Meter>{
    @Override
    public void flatMap(String s, Collector<Meter> collector) throws Exception {
        List<Meter> meters = JSONArray.parseArray(s, Meter.class);
        for (Meter meter : meters) {
            collector.collect(meter);
        }
    }
}
