package com.sunwin.metro.key;

import com.alibaba.fastjson.JSON;
import com.sunwin.metro.utils.PerStringUtils;
import org.apache.flink.api.java.functions.KeySelector;
import org.apache.flink.api.java.tuple.Tuple4;

/**
 * @program: sunwin_metro
 * @description: 地铁进行自定义分组（没有实现窗口）
 * @author: xuYJ
 * @create: 2021-01-15 11:53
 **/
public class MetroKeySelector implements KeySelector<Tuple4<String, Integer, Long, String>, String> {
    @Override
    public String getKey(Tuple4<String, Integer, Long, String> tuple4) throws Exception {
        String[] split = JSON.parseObject(tuple4.f3).getString("compname").split("_");
        return PerStringUtils.isNullOrEmpty(split[0]) ? split[1] : split[0];
    }
}
