package com.sunwin.metro.map;

import com.alibaba.fastjson.JSON;
import com.sunwin.metro.bean.DeviceWarn;
import com.sunwin.metro.bean.MetroDevice;
import com.sunwin.metro.utils.DateUtils;
import org.apache.flink.api.common.functions.MapFunction;
import org.apache.flink.api.java.tuple.Tuple2;

import java.util.Date;

/**
 * @program: sunwin_metro
 * @description: 把设备属性值转换成设备报警输出对象
 * @author: xuYJ
 * @create: 2021-03-08 15:12
 **/
public class DeviceAlarmMap implements MapFunction<Tuple2<String, MetroDevice>, DeviceWarn> {
    @Override
    public DeviceWarn map(Tuple2<String, MetroDevice> value) throws Exception {
        MetroDevice metroDevice = value.f1;
        return new DeviceWarn(metroDevice.getDevice_id(), metroDevice.getOriginal_compname(), value.f0, JSON.toJSONString(metroDevice), DateUtils.dateToStringWithFormat(new Date(), "yyyyMMddHHmmss"));
    }
}
