package com.sunwin.metro.map;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sunwin.metro.utils.websocket.ClientManager;
import org.apache.flink.api.common.functions.RichMapFunction;
import org.apache.flink.configuration.Configuration;

import java.util.List;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 验证设备通讯是否正常，结果发到mysql
 * @author: xuYJ
 * @create: 2021-02-19 10:50
 **/
public class DeviceNormalMap extends RichMapFunction<Map<String, List<String>>, String> {
    private ClientManager clientManager;
    @Override
    public void open(Configuration parameters) throws Exception {
        clientManager = new ClientManager();
    }

    @Override
    public String map(Map<String, List<String>> input) throws Exception {
        JSONArray array = new JSONArray();
        for (String s : input.get("devices")) {
            array.add("sw404:"+s.trim());
        }
        JSONObject object = new JSONObject();
        object.put("dpes", array);
        clientManager.connect("ws://127.0.0.1:12108/dpsubSys_websocket", object.toJSONString());
        return null;
    }
}
