package com.sunwin.metro.map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sunwin.metro.utils.DateUtils;
import org.apache.flink.api.common.functions.MapFunction;
import org.apache.flink.api.java.tuple.Tuple3;
import org.apache.flink.api.java.tuple.Tuple4;

/**
 * @program: sunwin_metro
 * @description: 把数据中时间戳转化成时间字符串（用来定义事件时间）
 * @author: xuYJ
 * @create: 2021-04-25 15:50
 **/
public class MeterTimeMap implements MapFunction<Tuple3<String, String, String>, Tuple4<String, String, String, Long>> {
    @Override
    public Tuple4<String, String, String, Long> map(Tuple3<String, String, String> tuple3) throws Exception {
        String f2 = tuple3.f2;
        JSONObject data = JSON.parseObject(JSON.parseObject(f2).getString("data"));
        JSONObject current = JSON.parseObject(data.getString("0"));
        long updateTime = DateUtils.stringToTimeStampWithFormat(current.getString("update_time"), "yyyy-MM-dd HH:mm:ss");
        return new Tuple4<>(tuple3.f0, tuple3.f1, tuple3.f2, updateTime);
    }
}
