package com.sunwin.metro.service;

import com.sunwin.metro.flatmap.DeviceClientFlatmap;
import com.sunwin.metro.map.DeviceClientMap;
import org.apache.flink.api.common.functions.Partitioner;
import org.apache.flink.streaming.api.datastream.DataStreamSource;

import java.util.List;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 从webSocket服务端采集设备数据信息
 * @author: xuYJ
 * @create: 2021-01-19 14:47
 **/
public class DeviceClient {

    public static void process(DataStreamSource<Map<String, List<String>>> source) {
        source
                .flatMap(new DeviceClientFlatmap())
                .keyBy(0)
                .map(new DeviceClientMap());
    }
}
