package com.sunwin.metro.service;

import com.alibaba.fastjson.JSON;
import com.sunwin.metro.bean.MetroDevice;
import com.sunwin.metro.consumer.TopicKeyWordsConsumer;
import com.sunwin.metro.filter.MetroFilterMp;
import com.sunwin.metro.flatmap.MetroDevicePropertyFlatmap;
import com.sunwin.metro.key.MetroKeySelector;
import com.sunwin.metro.process.MetroKeyProcess;
import org.apache.commons.io.FileUtils;
import org.apache.flink.api.java.tuple.Tuple2;
import org.apache.flink.api.java.tuple.Tuple4;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.datastream.SingleOutputStreamOperator;
import org.apache.flink.streaming.api.functions.sink.SinkFunction;
import org.apache.flink.util.OutputTag;

import java.io.File;

/**
 * @program: sunwin_metro
 * @description: 把kafka地铁数据整理写到txt
 * @author: xuYJ
 * @create: 2021-02-03 15:25
 **/
public class WriteMetroTxt implements TopicKeyWordsConsumer {

    @Override
    public void process(DataStreamSource<Tuple4<String, Integer, Long, String>> input) {
        OutputTag<Tuple2<String, Integer>> tag = new OutputTag<Tuple2<String, Integer>>("heavy") {
        };
        SingleOutputStreamOperator<String> process = input.filter(new MetroFilterMp())
                .keyBy(new MetroKeySelector()).process(new MetroKeyProcess(tag));
        process.flatMap(new MetroDevicePropertyFlatmap())
                .addSink(new SinkFunction<MetroDevice>() {
                    @Override
                    public void invoke(MetroDevice value, Context context) throws Exception {
                        FileUtils.write(new File("C:\\Users\\daoda\\Desktop\\新建文件夹\\metro.txt"), JSON.toJSONString(value) + "\n", "UTF-8", true);
                    }
                });
    }
}
