package com.sunwin.metro.sink.impala;

import com.sunwin.metro.bean.message.EquipmentWarn;
import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;

import java.sql.Connection;
import java.sql.PreparedStatement;

/**
 * @program: sunwin_metro
 * @description:impala插入数据
 * @author: xuYJ
 * @create: 2021-04-15 09:54
 **/
public class SinkToImpalaWarn extends RichSinkFunction<EquipmentWarn> {
    private Connection con = null;
    private PreparedStatement ps = null;

    @Override
    public void open(Configuration parameters) throws Exception {
        con = MysqlUtils.getImpalaCon(new BasicDataSource());
        super.open(parameters);
    }

    @Override
    public void close() throws Exception {
        ps.close();
        con.close();
        super.close();
    }

    @Override
    public void invoke(EquipmentWarn value, Context context) throws Exception {
        String sql = " INSERT  INTO  equipment_warn(" +
                "line, equipment_code, station, equipment_name, warn_type, warn_time, " +
                "current_time, flag ) " +
                "VALUES(?, ?, ?, cast (? as string), cast (? as string), ? , ? , ?)";
        ps = con.prepareStatement(sql);
        try {
            ps.setInt(1, value.getLine());
            ps.setInt(2, value.getEquipment_code());
            ps.setInt(3, value.getStation());
            ps.setString(4, value.getEquipment_name());
            ps.setString(5, value.getWarn_type());
            ps.setString(6, value.getWarn_time());
            ps.setString(7, value.getCurrent_time());
            ps.setString(8, value.getFlag());
            ps.addBatch();
            ps.executeBatch();
            con.commit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
