
package com.sunwin.metro.sink.mysql;

import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.flink.api.java.tuple.Tuple2;
import org.apache.flink.api.java.tuple.Tuple3;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;

import java.sql.Connection;
import java.sql.PreparedStatement;

/**
 * @author xuYJ
 */
public class SinkErrorMeterToMysql extends RichSinkFunction<Tuple3<String, String, String>> {
    PreparedStatement ps;
    BasicDataSource dataSource;
    private Connection connection;

    @Override
    public void open(Configuration parameters) throws Exception {
        super.open(parameters);
        dataSource = new BasicDataSource();
        connection = MysqlUtils.getMysqlCon(dataSource);
        //修改通讯状态
        String sql = "UPDATE meter SET communicate_ok = 0 WHERE meter_number = ? AND id = ?;";
        ps = this.connection.prepareStatement(sql);
    }

    @Override
    public void close() throws Exception {
        super.close();
        if (connection != null) {
            connection.close();
        }
        if (ps != null) {
            ps.close();
        }
    }

    @Override
    public void invoke(Tuple3<String, String, String> input, Context context) throws Exception {
        ps.setString(1, input.f1);
        ps.setString(2, input.f0);
        ps.addBatch();
        ps.executeBatch();
        connection.commit();
    }


}
