
package com.sunwin.metro.sink.mysql;

import com.sunwin.metro.bean.Meter;
import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;

import java.sql.Connection;
import java.sql.PreparedStatement;

/**
 * @author xuYJ
 */
public class SinkToMysql extends RichSinkFunction<Meter> {
    PreparedStatement ps;
    BasicDataSource dataSource;
    private Connection connection;

    @Override
    public void open(Configuration parameters) throws Exception {
        super.open(parameters);
        dataSource = new BasicDataSource();
        connection = MysqlUtils.getMysqlCon(dataSource);
        String sql = "REPLACE into meter(id, meter_number, meter_type, name, brand_name, person_name, " +
                "person_tel, is_online, install_location, meter_attribute, remarks, collector_id, " +
                "station_id, gmt_modified, gmt_create, meter_name) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);";
        ps = this.connection.prepareStatement(sql);
    }

    @Override
    public void close() throws Exception {
        super.close();
        if (connection != null) {
            connection.close();
        }
        if (ps != null) {
            ps.close();
        }
    }

    @Override
    public void invoke(Meter meter, Context context) throws Exception {
        ps.setString(1, meter.getId());
        ps.setString(2, meter.getMeterNumber());
        ps.setInt(3, meter.getMeterType());
        ps.setString(4, meter.getName());
        ps.setString(5, meter.getBrandName());
        ps.setString(6, meter.getPersonName());
        ps.setString(7, meter.getPersonTel());
        ps.setInt(8, meter.isOnline() ? 1 : 0);
        ps.setString(9, meter.getInstallLocation());
        ps.setString(10, meter.getMeterAttribute());
        ps.setString(11, meter.getRemarks());
        ps.setString(12, meter.getCollectorId());
        ps.setString(13, meter.getStationId());
        ps.setString(14, meter.getGmtModified());
        ps.setString(15, meter.getGmtCreate());
        ps.setString(16, meter.getMeterName());
        ps.addBatch();
        ps.executeBatch();
        connection.commit();
    }

}
