package com.sunwin.metro.source.http;

import com.alibaba.fastjson.JSONArray;
import com.chinaway.http.client.HttpClientResponse;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.metrics.reporter.Scheduled;
import org.apache.flink.streaming.api.functions.source.RichSourceFunction;

import java.util.HashMap;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: http数据源
 * @author: xuYJ
 * @create: 2021-04-14 09:37
 **/
public class HttpMeterAtt extends RichSourceFunction<String> {
    private  HttpClientResponse<String> httpClient;
    private  Map<String, String> params;
    private  boolean isRunning=true;
    @Override
    public void open(Configuration parameters) throws Exception {
         params = new HashMap<>(16);
         httpClient = new HttpClientResponse<>();
        super.open(parameters);
    }

    @Override
    public void close() throws Exception {
        super.close();
    }

    @Override
    public void run(SourceContext<String> sourceContext) throws Exception {
        while (isRunning){
            String type1 = httpClient.getForString("http://192.168.20.134:8083//home/getMeter/1", params, new HashMap<>(16));
            String type2 = httpClient.getForString("http://192.168.20.134:8083//home/getMeter/2", params, new HashMap<>(16));
            String type3 = httpClient.getForString("http://192.168.20.134:8083//home/getMeter/3", params, new HashMap<>(16));
            JSONArray out = new JSONArray();
            JSONArray array1 = JSONArray.parseArray(type1);
            JSONArray array2 = JSONArray.parseArray(type2);
            JSONArray array3 = JSONArray.parseArray(type3);
            out.addAll(array1);
            out.addAll(array2);
            out.addAll(array3);
            sourceContext.collect(out.toJSONString());
            Thread.sleep(1000*60*30L);
        }
    }

    @Override
    public void cancel() {
        isRunning=false;
    }
}
