package com.sunwin.metro.source.mysql;


import com.sunwin.metro.bean.DeviceName;
import com.sunwin.metro.bean.ErrorDevice;
import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.sql.*;
import java.util.ArrayList;
import java.util.List;

/**
 * @author xuYJ
 */
public class MysqlData {
    public static final Logger logger = LoggerFactory.getLogger(MysqlData.class);
    private static final Connection CONNECTION;

    static {
        CONNECTION =MysqlUtils.getMysqlCon(new BasicDataSource());
    }

    public static List<String> getWords(String table) throws Exception {
        String sql = "select device_name from " + table;
        List<String> devices = new ArrayList<>();
        PreparedStatement pStatement;
        try {
            pStatement = CONNECTION.prepareStatement(sql);
            ResultSet rs = pStatement.executeQuery();
            while (rs.next()) {
                devices.add(rs.getString("device_name"));
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
        return devices;
    }


    public static List<DeviceName> getWordsWithTime(String table, long time) throws Exception {
        String sql = "select device_name,send_time from " + table + " WHERE send_time > " +time;
        List<DeviceName> devices = new ArrayList<>();
        PreparedStatement pStatement;
        try {
            pStatement = CONNECTION.prepareStatement(sql);
            ResultSet rs = pStatement.executeQuery();
            while (rs.next()) {
                devices.add(new DeviceName(rs.getString("device_name"),rs.getLong("send_time")));
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
        return devices;
    }


    public static void insertData(List<ErrorDevice> values, String table) {
        PreparedStatement pstm;
        String sql = " REPLACE  INTO " + table + " (id,device_name ,result_info , send_time) VALUES(?,?,?,?)";
        try {
            pstm = CONNECTION.prepareStatement(sql);
            CONNECTION.setAutoCommit(false);
            for (ErrorDevice value : values) {
                pstm.setString(1, value.getId());
                pstm.setString(2, value.getDeviceName());
                pstm.setString(3, value.getResultInfo());
                pstm.setString(4, value.getDate());
                pstm.addBatch();
            }
            pstm.executeBatch();
            CONNECTION.commit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
