package com.sunwin.metro.source.mysql.message;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sunwin.metro.source.mysql.MysqlData;
import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.flink.api.java.tuple.Tuple2;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 查询所有设备id
 * @author: xuYJ
 * @create: 2021-05-31 11:44
 **/
public class QueryEquipment {
    public static final Logger logger = LoggerFactory.getLogger(MysqlData.class);
    private static final Connection CONNECTION;

    static {
        CONNECTION = MysqlUtils.getMysqlCon(new BasicDataSource());
    }

    public static void closeCon() throws Exception {
        CONNECTION.close();
    }
    public static JSONArray getId() throws Exception {
        String sql = "SELECT line,station,equipment_id,equipment_code FROM tst_equipment_life ";
        JSONArray array = new JSONArray();
        PreparedStatement pStatement;
        try {
            pStatement = CONNECTION.prepareStatement(sql);
            ResultSet rs = pStatement.executeQuery();
            while (rs.next()) {
                JSONObject json = new JSONObject();
                json.put("line",rs.getString("line"));
                json.put("station",rs.getString("station"));
                json.put("equipment_id",rs.getString("equipment_id"));
                json.put("equipment_code",rs.getString("equipment_code"));
                array.add(json);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
        return array;
    }

    public static Map<String,JSONArray>getWarnMessage() throws Exception {
        String sql = "SELECT id,type,type_name FROM ea_alarm ";
        HashMap<String, JSONArray> map = new HashMap<>(16);
        PreparedStatement pStatement;
        try {
            pStatement = CONNECTION.prepareStatement(sql);
            ResultSet rs = pStatement.executeQuery();
            while (rs.next()) {
                String id = String.valueOf(rs.getInt("id"));
                String type = String.valueOf(rs.getInt("type"));
                String typeName =rs.getString("type_name");
                if(map.containsKey(id)){
                    JSONArray array = map.get(id);
                    array.add(type+"_"+typeName);
                    map.put(id,array);
                }else {
                    JSONArray array = new JSONArray();
                    array.add(type+"_"+typeName);
                    map.put(id,array);
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
        return map;
    }

    public static Map<String,String>getEquipmentName() throws Exception {
        String sql = "SELECT equipment_id,equipment_name  FROM tste_equipmentname ";
        HashMap<String, String> map = new HashMap<>(16);
        PreparedStatement pStatement;
        try {
            pStatement = CONNECTION.prepareStatement(sql);
            ResultSet rs = pStatement.executeQuery();
            while (rs.next()) {
                String id = String.valueOf(rs.getInt("equipment_id"));
                String name = rs.getString("equipment_name");
                map.put(id,name);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
        return map;
    }

    public static void main(String[] args) throws Exception {
        Map<String, String> equipmentName = getEquipmentName();
        for (Map.Entry<String, String> entry : equipmentName.entrySet()) {
            System.out.println("entry = " + entry);
        }
    }
}
