package com.sunwin.metro.start;


import com.sunwin.metro.config.ConfigFileHandler;
import com.sunwin.metro.service.DeviceNormal;
import com.sunwin.metro.service.DeviceClient;
import com.sunwin.metro.service.EnergyConsumption;
import com.sunwin.metro.source.http.HttpMeterAtt;
import com.sunwin.metro.source.http.HttpMeterMsg;
import com.sunwin.metro.source.mysql.MysqlSource;
import com.sunwin.metro.source.mysql.MysqlSourceTime;
import com.sunwin.metro.utils.DateUtils;
import com.sunwin.metro.utils.MysqlUtils;
import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.commons.io.FileUtils;
import org.apache.flink.api.common.restartstrategy.RestartStrategies;
import org.apache.flink.api.java.tuple.Tuple4;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.contrib.streaming.state.RocksDBStateBackend;
import org.apache.flink.streaming.api.CheckpointingMode;
import org.apache.flink.streaming.api.TimeCharacteristic;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.datastream.SingleOutputStreamOperator;
import org.apache.flink.streaming.api.environment.CheckpointConfig;
import org.apache.flink.streaming.api.environment.LocalStreamEnvironment;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;
import org.apache.flink.streaming.api.functions.sink.SinkFunction;
import org.apache.flink.streaming.api.functions.source.SourceFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * @author xuYJ
 * @description: 通讯正常
 * @create: 2020-08-26 14:10
 */
public class StartMonitor {
    public static final Logger logger = LoggerFactory.getLogger(StartMonitor.class);

    public static void main(String[] args) throws Exception {
        LocalStreamEnvironment env = StreamExecutionEnvironment.createLocalEnvironment();
        StreamPro.envPro(env, args[0]);
        switch (args[0]) {
            case "device-normal":
                DataStreamSource<Map<String, List<String>>> source = env.addSource(new MysqlSource(30 * 60 * 1000L));
                DeviceNormal.process(source);
                env.execute("device-normal");
                break;
            case "device-client":
                DataStreamSource<Map<String, List<String>>> source2 = env.addSource(new MysqlSourceTime(5 * 1000L));
                DeviceClient.process(source2);
                env.execute("device-client");
                break;
            case "energy-consumption":
                SingleOutputStreamOperator<String> source3 = env.setParallelism(1).addSource(new HttpMeterAtt());
                SingleOutputStreamOperator<Tuple4<String, String, String, String>> source4 = env.addSource(new HttpMeterMsg());
                EnergyConsumption.process(source3, source4);
                env.execute("energy-consumption");
                break;
            default:
                break;
        }
    }
}
