package com.sunwin.metro.start;

import com.sunwin.metro.config.ConfigFileHandler;
import org.apache.flink.api.common.restartstrategy.RestartStrategies;
import org.apache.flink.contrib.streaming.state.RocksDBStateBackend;
import org.apache.flink.streaming.api.CheckpointingMode;
import org.apache.flink.streaming.api.TimeCharacteristic;
import org.apache.flink.streaming.api.environment.CheckpointConfig;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * @program: sunwin_metro
 * @description: 实时流配置
 * @author: xuYJ
 * @create: 2021-04-26 17:29
 **/
public class StreamPro {
    public static void envPro (StreamExecutionEnvironment env,String arg) throws IOException {
        env.setStreamTimeCharacteristic(TimeCharacteristic.EventTime);
        env.setParallelism(1);
        env.setRestartStrategy(RestartStrategies.fixedDelayRestart(10, org.apache.flink.api.common.time.Time.of(5, TimeUnit.SECONDS)));
        env.setStateBackend(new RocksDBStateBackend(ConfigFileHandler.getCheckPoint() + arg + "/", true).getCheckpointBackend());
        env.enableCheckpointing(10000 * 6);
        env.getCheckpointConfig().setMinPauseBetweenCheckpoints(10000 * 3);
        env.getCheckpointConfig().setCheckpointingMode(CheckpointingMode.EXACTLY_ONCE);
        env.getCheckpointConfig().setCheckpointTimeout(60000 * 10);
        env.getCheckpointConfig().setTolerableCheckpointFailureNumber(100);
        env.getCheckpointConfig().setMaxConcurrentCheckpoints(1);
        env.getCheckpointConfig().enableExternalizedCheckpoints(CheckpointConfig.ExternalizedCheckpointCleanup.RETAIN_ON_CANCELLATION);

    }
}
