package com.sunwin.metro.utils;

import com.sunwin.metro.config.ConfigFileHandler;
import org.apache.commons.dbcp2.BasicDataSource;

import java.sql.Connection;

/**
 * @program: sunwin_metro
 * @description: mysql连接器
 * @author: xuYJ
 * @create: 2021-04-14 14:11
 **/
public class MysqlUtils {

    public static Connection getMysqlCon(BasicDataSource dataSource) {
        dataSource.setDriverClassName("com.mysql.cj.jdbc.Driver");
        dataSource.setUrl(ConfigFileHandler.getMysqlUrl());
        dataSource.setUsername(ConfigFileHandler.getMysqlUserName());
        dataSource.setPassword(ConfigFileHandler.getMysqlPassWord());
        dataSource.setInitialSize(10);
        dataSource.setMaxTotal(50);
        dataSource.setMinIdle(2);

        Connection con = null;
        try {
            con = dataSource.getConnection();
            con.setAutoCommit(false);
        } catch (Exception ignored) {
        }
        return con;
    }

    public static Connection getImpalaCon(BasicDataSource dataSource) {
        dataSource.setDriverClassName("com.cloudera.impala.jdbc41.Driver");
        dataSource.setUrl("jdbc:impala://192.168.20.63:21050/urtdb");
        dataSource.setInitialSize(10);
        dataSource.setMaxTotal(50);
        dataSource.setMinIdle(2);

        Connection con = null;
        try {
            con = dataSource.getConnection();
            con.setAutoCommit(false);
            System.out.println("创建连接池：" + con);
        } catch (Exception ignored) {
        }
        return con;
    }
}
