/*************************************************
 Copyright © 2010 boryou. All rights reserved.

 File name: Sign.java
 Version: 1.0
 Author: 高威
 Date: Nov 9, 2010
 Description:
 History:
 1. Date: Nov 9, 2010
 Author: 高威
 Modification:
 2. ...
 *************************************************/
package com.sunwin.metro.utils;

import java.math.BigInteger;
import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;


/**
 * 签名
 * @author kane
 */
public class Sign {

    private static final int MD5LEN = 16;

    public static byte[] getSign(String text) {
        byte[] sign = {-44, 29, -116, -39, -113, 0, -78, 4, -23, -128, 9, -104, -20, -8, 66, 126};
        if (text == null) {
            return sign;
        }
        try {
            sign = text.getBytes(StandardCharsets.UTF_8);
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        try {
            MessageDigest digester = MessageDigest.getInstance("MD5");
            digester.update(sign);
            sign = digester.digest();
            if (sign.length == MD5LEN) {
                return sign;
            }
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return new byte[]{-44, 29, -116, -39, -113, 0, -78, 4, -23, -128, 9, -104, -20, -8, 66, 126};
    }


    public static long getMd5(String text) {
        return new BigInteger(Sign.getSign(text)).longValue();
    }


    public static String byteToString(byte[] sign) {
        StringBuilder digestHexStr = new StringBuilder();
        for (byte b : sign) {
            digestHexStr.append(byteHex(b));
        }
        return digestHexStr.toString();
    }

    private static String byteHex(int ib) {

        byte[] digit = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
        byte[] ob = new byte[2];
        int h;
        int l;
        if (ib < 0) {

            ib = -ib;
            ib = ib - 1;
            // 补码to原码
            h = (ib >> 4) & 0x0f;
            l = ib & 0x0f;
            h = h | 0x8;
        } else {
            h = (ib >> 4) & 0x0f;
            l = ib & 0x0f;
        }

        ob[0] = digit[h];
        ob[1] = digit[l];
        return new String(ob);
    }


}
