package com.sunwin.metro.utils.websocket;



import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sunwin.metro.bean.ErrorDevice;
import com.sunwin.metro.source.mysql.MysqlData;
import com.sunwin.metro.utils.DateUtils;
import com.sunwin.metro.utils.Md5Utils;
import com.sunwin.metro.utils.PerStringUtils;
import org.apache.commons.lang3.StringEscapeUtils;
import org.java_websocket.WebSocket;
import java.io.IOException;
import java.net.URI;
import java.util.Collections;
import java.util.Date;

/**
 * @program: opcClient
 * @author: xuYJ
 * @create: 2020-12-29 13:17
 **/
public class ClientManager {

    private ClientSocket socket;

    public void connect(String url, String json) {
        try {
            socket = new ClientSocket(this, new URI(url));
            socket.connect();
            while (!socket.getReadyState().equals(WebSocket.READYSTATE.OPEN)) {
                Thread.sleep(10000);
            }
            socket.send(json);
        } catch (Exception e) {
        }
    }

    public void receive(String message) throws IOException {
        if (!PerStringUtils.isNullOrEmpty(message)) {
            if (message.contains("errorDes")) {
                System.out.println("message = " + message);
                JSONObject jsonObject = JSON.parseObject(message);
                String errorDes = jsonObject.getString("errorDes");
                String[] split = errorDes.split("--");
                MysqlData.insertData(Collections.singletonList(new ErrorDevice(Md5Utils.getDeviceIdNoTime(split[0]),split[0], "通讯异常："+split[1], DateUtils.dateToLongStringNoSep(new Date()))), "metro_device_error");
            } else {
                message = StringEscapeUtils.unescapeJava(message).replace("\"{", "{").replace("}\n\"", "}");
                JSONObject object = JSON.parseObject(message);
                String deviceName = object.getString("compname");
                String stationId = object.getString("stationId");
                String name = stationId + ":" + deviceName;
                MysqlData.insertData(Collections.singletonList(new ErrorDevice(Md5Utils.getDeviceIdNoTime(name),name, "通讯正常", DateUtils.dateToLongStringNoSep(new Date()))), "metro_device_error");
            }
        }
    }
}
