package com.sunwin.metro.utils.websocket;


import org.java_websocket.client.WebSocketClient;
import org.java_websocket.handshake.ServerHandshake;
import java.io.IOException;
import java.net.URI;

/**
 * @program: opcClient
 * @description: 客户端
 * @author: xuYJ
 * @create: 2020-12-29 13:15
 **/
public class ClientSocket extends WebSocketClient {

    private final ClientManager clientManager;

    public ClientSocket(ClientManager clientManager,URI serverUrl) {
        super(serverUrl);
        this.clientManager =clientManager;
    }

    @Override
    public void onClose(int arg0, String arg1, boolean arg2) {
        System.out.println("关闭客户端 ");
    }


    @Override
    public void onError(Exception arg0) {
        System.out.println("执行异常...");
    }

    @Override
    public void onMessage(String arg0) {
        try {
            clientManager.receive(arg0);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onOpen(ServerHandshake arg0) {
        System.out.println("成功连接...");
    }
}

