package com.sunwin.metro.watermark;

import com.sunwin.metro.bean.MetroDevice;
import com.sunwin.metro.utils.DateUtils;
import org.apache.flink.streaming.api.functions.timestamps.BoundedOutOfOrdernessTimestampExtractor;
import org.apache.flink.streaming.api.windowing.time.Time;

/**
 * @program: sunwin_metro
 * @description: 设置水位线，解析设备源数据中的时间戳字段
 * @author: xuYJ
 * @create: 2021-03-08 15:24
 **/
public class DeviceWaterLine extends BoundedOutOfOrdernessTimestampExtractor<MetroDevice>{
    public DeviceWaterLine(Time time) {
        super(time);
    }

    @Override
    public long extractTimestamp(MetroDevice metroDevice) {
        return DateUtils.getTimestamp(metroDevice.getAttribute_time());
    }
}
