package com.sunwin.metro.watermark;


import org.apache.flink.api.java.tuple.Tuple4;
import org.apache.flink.streaming.api.functions.timestamps.BoundedOutOfOrdernessTimestampExtractor;
import org.apache.flink.streaming.api.windowing.time.Time;

/**
 * @program: sunwin_metro
 * @description: 设置水位线，解析设备源数据中的时间戳字段
 * @author: xuYJ
 * @create: 2021-03-08 15:24
 **/
public class MeterWaterLine extends BoundedOutOfOrdernessTimestampExtractor<Tuple4<String, String, String, Long>>{
    public MeterWaterLine(Time time) {
        super(time);
    }

    @Override
    public long extractTimestamp(Tuple4<String, String, String, Long> tuple4) {
        return tuple4.f3;
    }
}
